C
C     Program to change plate boundaries from one "old" set of rotations of Pacific and African plate
C     to new set of rotations
C
      implicit real*8(a-h,o-z)
      parameter (pi=3.14159265358979324,conv=pi/180.,nbd=1000,
     2  npt=1000,npt2=10000,nref=60)
      character*60 infile,out1,out2,out3,out4,parot1,afrot1,
     2 parot2,afrot2,outfile,c60,c60a(100)
      character*2 c1,c1a(100)
      dimension ommpa1(3,3),ommaf1(3,3),ommpa2(3,3),ommaf2(3,3),
     1 rt1(3),rt2(3),rb1(3),rb2(3),rtmid(3),rbmid(3),
     2 n1(nbd),n2(nbd),n3(nbd),n4(nbd),n5(nbd),
     3 n1b(nbd),n2b(nbd),n3b(nbd),n4b(nbd),n5b(nbd),
     4 rlat(nbd,npt),rlon(nbd,npt),rlatb(nbd,npt),rlonb(nbd,npt),
     5 rlatrd(npt2),rlonrd(npt2),rlatout(nref),rlonout(nref),
     6 n2c(npt2),n3c(npt2),n4c(npt2),n5c(npt2),
     7 kcross(60),kconn(1000),kconn2(1000),
     8 jconn(1000),jconn2(1000),nebconn(0:1000),nebconn2(1000),
     9 nbc(nbd),nec(nbd),nap(nbd),n4d(nbd),n5d(nbd)
       dimension rlat1in(10000),rlat2in(10000),
     2 rlon1in(10000),rlon2in(10000),
     3 ipl1in(10000),ipl2in(10000),ipl3in(10000),ipl4in(10000),
     4 idpl(100),idpl2(100),n0ar(100),rdlat(100,2000),rdlon(100,2000),
     5 i9999a(100),i0a(100),i0ba(100),i999a(100),i0ca(100),nptb(100)

      rninetynine=99.
      ntwo=2
      nthree=3
      iend=0
      read (5,*) n0
C
C     New rotations Pacific and Africa (corresponding to new boundary set to be created)
C
      irot=0
      read (5,60) parot1
      read (5,60) afrot1
      open (1,file=parot1)
      open (2,file=afrot1)
C
C     Old rotation (used to generate existing boundary set) 
C
      read (5,60) parot2
      read (5,60) afrot2
      open (3,file=parot2)
      open (4,file=afrot2)
      read (5,60) infile
      read (5,60) outfile
  60  format (a60)
      open (11,file=infile)
      open (12,file=outfile)
      read (11,1460) i9999,i0,c60
 1414 format (i4,1x,i4)
 1460 format (i4,1x,i4,a60)
      read (11,211) idpl2n,time1,time2,c1,i0b,i999,i0c,n0n
      if (time1.eq.0) then
        write (12,1414) i9999,i0
        write (12,211) idpl2n,time1,time2,c1,i0b,i999,i0c,n0n
      endif
 211  format (i4,2f7.1,1x,a2,3i4,i6)
      do i=0,100
        print *,i
        do ipl=1,100
          time1p=time1
          time2p=time2
          n0ar(ipl)=n0n
          idpl2(ipl)=idpl2n
          i9999a(ipl)=i9999
          i0a(ipl)=i0
          c1a(ipl)=c1
          i0ba(ipl)=i0b
          i999a(ipl)=i999
          i0ca(ipl)=i0c
          c60a(ipl)=c60
          idpl(ipl)=ipl
          do ipt=1,n0ar(ipl)
            read (11,9494) rdlat(ipl,ipt),rdlon(ipl,ipt)
 9494       format (f9.4,1x,f9.4)
            if (time1.eq.0) write (12,9494) 
     2        rdlat(ipl,ipt),rdlon(ipl,ipt)
          enddo
          read (11,9494) rlatf,rlonf
          if (time1.eq.0) write (12,9494) rlatf,rlonf
          read (11,1460,end=98) i9999,i0,c60
          read (11,211) idpl2n,time1,time2,c1,i0b,i999,i0c,n0n
          if (time1.eq.0) then
            write (12,1414) i9999,i0
            write (12,211) idpl2n,time1,time2,c1,i0b,i999,i0c,n0n
          endif
          if (time1.gt.time1p) goto 99
        enddo
   98   iend=1
   99   npl=ipl
        if (time1p.gt.0) then
C
C     Pre-processing part 1: disassemble boundaries around each plate into individual segments
C
        call disassemble(npl,idpl,idpl2,n0ar,rdlat,rdlon,npttot,
     2  rlat1in,rlon1in,rlat2in,rlon2in,ipl1in,ipl2in,ipl3in,ipl4in)
C
C     Pre-processing part 2: assemble individual plate boundaries
C
        call assemble_sub(npttot,rlat1in,rlon1in,
     2   rlat2in,rlon2in,ipl1in,ipl2in,ipl3in,ipl4in,
     3   j0,n1,n2,n3,n4,n5,rlat,rlon)

C
C     Step 1: "disonnect and refine": Rotate boundaries from "old" to "new" system
C     Refine boundaries such that distance of points does not exceed a certain maximum
C
C     Compute rotation matrices from rotation vectors. Only for n0-1
C     sets of plate boundaries, since there are only n0-1 suitable sets
C     of rotation vectors. Earlier boundaries remain unchanged.
C
        irot=irot+1
        if (irot.le.n0) then
          read (1,*) time,rlatrot,rlonrot,rmag
          call chang(rlatrot,rlonrot,rmag,ommpa1)
          read (2,*) time,rlatrot,rlonrot,rmag
          call chang(rlatrot,rlonrot,rmag,ommaf1)
          read (3,*) time,rlatrot,rlonrot,rmag
          rmag=-rmag
          call chang(rlatrot,rlonrot,rmag,ommpa2)
          read (4,*) time,rlatrot,rlonrot,rmag
          rmag=-rmag
          call chang(rlatrot,rlonrot,rmag,ommaf2)
        endif

        read (5,60) out1
        read (5,60) out2
        read (5,60) out3
        read (5,60) out4
        open (7,file=out1)
        open (8,file=out2)
        open (9,file=out3)
        open (10,file=out4)
        ja=0
        jp=0
        jap=0
        do j=1,j0
C
C         Separate into "African" and "Pacific" set of plates.
C         Back to 80 Ma (i<=8), no Phoenix plate exists. 
C         The following plates are included in the Pacific set of plates, 
C         which, apart from that, includes those and only those with plate ID # >900:
C         0-10 Ma: 802 (Antarctica), 820 (Scotia)
C         10-20 Ma: 802, 840
C         20-60 Ma: 802, 804
C         60-80 Ma: 802
C
          if (i.eq.1) then
          if ((n4(j).eq.820).or.(n4(j).gt.900)
     2    .or.(n4(j).eq.840).or.(n4(j).eq.802)) then
            n4d(j)=2
          else 
            n4d(j)=1
          endif
          if ((n5(j).eq.820).or.(n5(j).gt.900)
     2    .or.(n5(j).eq.840).or.(n5(j).eq.802)) then
            n5d(j)=2
          else 
            n5d(j)=1
          endif
          else if ((i.gt.2).and.(i.le.6)) then
          if ((n4(j).eq.804).or.(n4(j).gt.900)
     2    .or.(n4(j).eq.840).or.(n4(j).eq.802)) then
            n4d(j)=2
          else 
            n4d(j)=1
          endif
          if ((n5(j).eq.804).or.(n5(j).gt.900)
     2    .or.(n5(j).eq.840).or.(n5(j).eq.802)) then
            n5d(j)=2
          else 
            n5d(j)=1
          endif
          else if (i.le.8) then
          if ((n4(j).eq.802).or.(n4(j).eq.804)
     2    .or.(n4(j).eq.840).or.(n4(j).gt.900)) then
            n4d(j)=2
          else 
            n4d(j)=1
          endif
          if ((n5(j).eq.802).or.(n5(j).eq.804)
     2    .or.(n5(j).eq.840).or.(n5(j).gt.900)) then
            n5d(j)=2
          else 
            n5d(j)=1
          endif
          else
          if (n4(j).gt.900) then
            n4d(j)=2
          else 
            n4d(j)=1
          endif
          if (n5(j).gt.900) then
            n5d(j)=2
          else 
            n5d(j)=1
          endif
          endif
C     
C     Count boundaries within African set of plates (nap=1)
C                      within Pacific set of plates (nap=2)
C                      between African and Pacific sets (nap=3)
C
          if ((n4d(j).eq.1).and.(n5d(j).eq.1)) then
            ja=ja+1
            nap(j)=1
          else if ((n4d(j).eq.2).and.(n5d(j).eq.2)) then
            jp=jp+1
            nap(j)=2
          else
            jap=jap+1
            nap(j)=3
          endif

          kout=0
          dmax=3
          do k=1,n1(j)
C
C     Boundaries within Pacific set of plates (n4d=2 and n5d=2) are rotated according to the old and new Pacific rotations
C     Boundaries between Pacific and African sets ((n4d=2 and n5d=1) or (n4d=1 and n5d=2)) or within African set of plates
C     (n4d=1 and n5d=1) are rotated according to the old and new African rotations.
C
            if ((n4d(j).eq.2).and.(n5d(j).eq.2).and.(i.le.n0)) then
              call rotate(rlat(j,k),rlon(j,k),ommpa1,ommpa2)
            else if (i.le.n0) then
              call rotate(rlat(j,k),rlon(j,k),ommaf1,ommaf2)
            endif
C
C     Plate boundaries are refined such that the distance between points is less than dmax degrees.
C
            if (kout.eq.0) then
              nout=1
              rlatout(1)=rlat(j,k)
              rlonout(1)=rlon(j,k)
            else
              call refine(rlat(j,k),rlon(j,k),rlatb(j,kout),
     2          rlonb(j,kout),dmax,nout,rlatout,rlonout)
            endif
            do l=1,nout
              rlatb(j,kout+l)=rlatout(l)
              rlonb(j,kout+l)=rlonout(l)
            enddo
            kout=kout+nout
          enddo
          n1(j)=kout
          do k=1,n1(j)
            rlon(j,k)=rlonb(j,k)
            rlat(j,k)=rlatb(j,k)
          enddo
C
C     Plate boundaries have at least three points, i.e. if there are two points only, a third point
C     is introduced in the middle
C
          if (n1(j).eq.2) then
            n1(j)=3
            rtmid(1)=(cos(conv*rlat(j,1))*cos(conv*rlon(j,1))+
     2               cos(conv*rlat(j,2))*cos(conv*rlon(j,2)))/2.
            rtmid(2)=(cos(conv*rlat(j,1))*sin(conv*rlon(j,1))+
     2               cos(conv*rlat(j,2))*sin(conv*rlon(j,2)))/2.
            rtmid(3)=(sin(conv*rlat(j,1))+sin(conv*rlat(j,2)))/2.
            call car2sph(rtmid,rlatmid,rlonmid)
            rlat(j,3)=rlat(j,2)
            rlon(j,3)=rlon(j,2)
            rlat(j,2)=rlatmid
            rlon(j,2)=rlonmid
          endif
        enddo
C
C     Re-order boundaries. This is needed because the number of boundaries between Pacific and African sets does not necessarily
C     stay the same under the re-connections. Put boundaries within African set first, followed by boundaries within Pacific set,
C     followed by boundaries between African and Pacific sets. In the last group, some boundaries are reversed in order such that 
C     always the plate in the Pacific set is on the right side and the plate in the African set on the left side.
C
        ia=0
        ip=0
        iap=0
        do j=1,j0
          if (nap(j).eq.1) then
            ia=ia+1
            n1b(ia)=n1(j)
            n2b(ia)=n2(j)
            n3b(ia)=n3(j)
            n4b(ia)=n4(j)
            n5b(ia)=n5(j)
            do k=1,n1(j)
              rlonb(ia,k)=rlon(j,k)
              rlatb(ia,k)=rlat(j,k)
            enddo
          else if (nap(j).eq.2) then
            ip=ip+1
            n1b(ip+ja)=n1(j)
            n2b(ip+ja)=n2(j)
            n3b(ip+ja)=n3(j)
            n4b(ip+ja)=n4(j)
            n5b(ip+ja)=n5(j)
            do k=1,n1(j)
              rlonb(ip+ja,k)=rlon(j,k)
              rlatb(ip+ja,k)=rlat(j,k)
            enddo
          else if ((n4d(j).eq.1).and.(n5d(j).eq.2)) then
            iap=iap+1
            n1b(iap+ja+jp)=n1(j)
            n2b(iap+ja+jp)=n2(j)
            n3b(iap+ja+jp)=n3(j)
            n4b(iap+ja+jp)=n4(j)
            n5b(iap+ja+jp)=n5(j)
            do k=1,n1(j)
              rlonb(iap+ja+jp,k)=rlon(j,k)
              rlatb(iap+ja+jp,k)=rlat(j,k)
            enddo
          else if ((n4d(j).eq.2).and.(n5d(j).eq.1)) then
            iap=iap+1
            n1b(iap+ja+jp)=n1(j)
            n2b(iap+ja+jp)=n3(j)
            n3b(iap+ja+jp)=n2(j)
            n4b(iap+ja+jp)=n5(j)
            n5b(iap+ja+jp)=n4(j)
            do k=1,n1(j)
              rlonb(iap+ja+jp,k)=rlon(j,n1(j)+1-k)
              rlatb(iap+ja+jp,k)=rlat(j,n1(j)+1-k)
            enddo
          else
            print *,'plate boundary could not be assigned to group'
          endif
        enddo
        do j=1,j0
          n1(j)=n1b(j)
          n2(j)=n2b(j)
          n3(j)=n3b(j)
          n4(j)=n4b(j)
          n5(j)=n5b(j)
          do k=1,n1(j)
            rlon(j,k)=rlonb(j,k)
            rlat(j,k)=rlatb(j,k)
          enddo
        enddo
C
C     Step 2: Connect boundaries between Pacific and African set to one continuous line going clockwise around the Pacific set -
C     the "Pacific-African boundary".
C     Mark for each segment between two points which plate of the African set (n2c,n4c) and which plate on the Pacific set (n3c,n5c)
C     it is bounded by. These numbers are assigned to the "end" i.e. second point of the segment, except for the first segment 
C     where it is assigned to both points.
C     First part of boundary:
C
        do k=1,n1(ja+jp+1)
          rlatrd(k)=rlat(ja+jp+1,k)
          rlonrd(k)=rlon(ja+jp+1,k)
          n2c(k)=n2(ja+jp+1)
          n3c(k)=n3(ja+jp+1)
          n4c(k)=n4(ja+jp+1)
          n5c(k)=n5(ja+jp+1)
        enddo
        krd=n1(ja+jp+1)

  199   do j=ja+jp+2,j0
C
C     Find the next part of the boundary
C
          do jb=ja+jp+2,j0
            if ((dist(rlat(jb,1),rlon(jb,1),
     3              rlatrd(krd),rlonrd(krd)).lt.0.00005)) then
              do k=1,n1(jb)-1
                rlatrd(krd+k)=rlat(jb,k+1)
                rlonrd(krd+k)=rlon(jb,k+1)
                n2c(krd+k)=n2(jb)
                n3c(krd+k)=n3(jb)
                n4c(krd+k)=n4(jb)
                n5c(krd+k)=n5(jb)
              enddo
              krd=krd+n1(jb)-1
              goto 299
            endif
          enddo
  299     continue
          if (dist(rlatrd(krd),rlonrd(krd),rlatrd(1),rlonrd(1))
     2         .lt.0.00005) goto 399
        enddo
  399   continue
C
C     Step 3: Mark endpoints of boundaries within Pacific set. 
C     nbc(j)=1/0 first point "connected" with another boundary y/n
C     nec(j)=1/0 last point "connected" with another boundary y/n
C
        do j=ja+1,ja+jp
          nbc(j)=0
          nec(j)=0
          do jb=ja+1,ja+jp
            if ((j.ne.jb).and.((dist
     2      (rlat(j,1),rlon(j,1),rlat(jb,1),rlon(jb,1))
     3      .lt.0.00005).or.(dist
     4      (rlat(j,1),rlon(j,1),rlat(jb,n1(jb)),rlon(jb,n1(jb)))
     5      .lt.0.00005))) nbc(j)=nbc(j)+1
            if ((j.ne.jb).and.((dist
     2      (rlat(j,n1(j)),rlon(j,n1(j)),rlat(jb,1),rlon(jb,1))
     3      .lt.0.00005).or.(dist
     4     (rlat(j,n1(j)),rlon(j,n1(j)),rlat(jb,n1(jb)),rlon(jb,n1(jb)))
     5      .lt.0.00005))) nec(j)=nec(j)+1
          enddo
        enddo
C
C     Step 4: Remove all points of boundaries within Pacific set that are on one of the “African set" plates.
C
        do j=ja+1,ja+jp
          ncross=0
          do k2=1,n1(j)-1
            do k1=1,krd-1
              rt1(1)=cos(conv*rlat(j,k2))*cos(conv*rlon(j,k2))
              rt1(2)=cos(conv*rlat(j,k2))*sin(conv*rlon(j,k2))
              rt1(3)=sin(conv*rlat(j,k2))
              rt2(1)=cos(conv*rlat(j,k2+1))*cos(conv*rlon(j,k2+1))
              rt2(2)=cos(conv*rlat(j,k2+1))*sin(conv*rlon(j,k2+1))
              rt2(3)=sin(conv*rlat(j,k2+1))
              rb1(1)=cos(conv*rlatrd(k1))*cos(conv*rlonrd(k1))
              rb1(2)=cos(conv*rlatrd(k1))*sin(conv*rlonrd(k1))
              rb1(3)=sin(conv*rlatrd(k1))
              rb2(1)=cos(conv*rlatrd(k1+1))*cos(conv*rlonrd(k1+1))
              rb2(2)=cos(conv*rlatrd(k1+1))*sin(conv*rlonrd(k1+1))
              rb2(3)=sin(conv*rlatrd(k1+1))
              rtmid(1)=(rt1(1)+rt2(1))/2.
              rtmid(2)=(rt1(2)+rt2(2))/2.
              rtmid(3)=(rt1(3)+rt2(3))/2.
              rbmid(1)=(rb1(1)+rb2(1))/2.
              rbmid(2)=(rb1(2)+rb2(2))/2.
              rbmid(3)=(rb1(3)+rb2(3))/2.
              call car2sph(rtmid,rtlatmid,rtlonmid)
              call car2sph(rbmid,rblatmid,rblonmid)
C
C     Determine line crossings.
C     Only count when midpoints are less than 90 degrees apart to avoid
C     crossings of antipodal lines
C
              if ((cross(rt1,rt2,rb1,rb2).gt.0.5).and.(dist
     2        (rtlatmid,rtlonmid,rblatmid,rblonmid).lt.90)) then
                ncross=ncross+1
                kcross(ncross)=k2  
                print *,kcross(ncross)
                print *,rlatrd(k1),rlonrd(k1),rlatrd(k1+1),rlonrd(k1+1)
                print *,rlat(j,k2),rlon(j,k2),rlat(j,k2+1),rlon(j,k2+1)
              endif
            enddo
          enddo
          if (ncross.ge.1) then
            if ((nbc(j).eq.2).and.(nec(j).le.1)) then
              n1(j)=kcross(1)
              print *,'Crossing(s) for boundary connected at beginning'
              print *,'Keep beginning part'
            else if ((nbc(j).le.1).and.(nec(j).eq.2)) then
              print *,'Crossing(s) for boundary connected at end'
              print *,'Keep end part'
              n1(j)=n1(j)-kcross(ncross)
              do k=1,n1(j)
                rlat(j,k)=rlat(j,k+kcross(ncross))
                rlon(j,k)=rlon(j,k+kcross(ncross))
              enddo
            else if ((nbc(j).le.1).and.(nec(j).le.1)) then
              print *,'Crossing for unconnected boundary'
              kdiffmax=kcross(1)-1
              ikeep=1
              if (ncross.ge.2) then
                do icross=1,ncross-1
                  if (kcross(icross+1)-kcross(icross).gt.kdiffmax) then
                    kdiffmax=kcross(icross+1)-kcross(icross)
                    ikeep=icross+1
                  endif
                enddo
              endif
              if (n1(j)-kcross(ncross).gt.kdiffmax) ikeep=ncross+1
              if (ikeep.eq.1) then
                n1(j)=kcross(1)
                print *,'Keep longest part (beginning part)'
              else if (ikeep.eq.ncross+1) then
                n1(j)=n1(j)-kcross(ncross)
                do k=1,n1(j)
                  rlat(j,k)=rlat(j,k+kcross(ncross))
                  rlon(j,k)=rlon(j,k+kcross(ncross))
                enddo
                print *,'Keep longest part (end part)'
              else
                n1(j)=kcross(ikeep)-kcross(ikeep-1)
                do k=1,n1(j)
                  rlat(j,k)=rlat(j,k+kcross(ikeep-1))
                  rlon(j,k)=rlon(j,k+kcross(ikeep-1))
                enddo
                print *,'Keep longest part (middle part)'
              endif
            else if ((nbc(j).eq.2).and.(nec(j).eq.2)) then
              print *,'SPECIAL CASE REQUIRES HAND-EDITING'
              print *,'Crossing(s) for bdry connected both ends'
              do k=1,n1(j)
                print *,i,rlat(j,k),rlon(j,k)
              enddo
            endif
          endif
        enddo
C
C     Step 5: Connect boundaries withing Pacific set to closest point on Pacific-African boundary 
C     That is, add that point at any line end that is marked as “unconnected”
C     For each connection
C     --> Mark which point along the Pacific-African boundary it is connected to (kconn)
C     --> Which boundary is connecting to that point (jconn)
C     --> Whether it is the beginning point (nebconn=1) or end point (nebconn=2) of that boundary that is connecting to
C
        iconn=0
        do j=ja+1,ja+jp
          if (nbc(j).le.1) then
            do k=n1(j),1,-1
              rlat(j,k+1)=rlat(j,k)
              rlon(j,k+1)=rlon(j,k)
            enddo
            n1(j)=n1(j)+1
            distmin=180.
            do k=1,krd
              distnew=dist(rlat(j,2),rlon(j,2),rlatrd(k),rlonrd(k))
              if (distnew.lt.distmin) then
                distmin=distnew
                kmin=k
              endif
            enddo
            rlat(j,1)=rlatrd(kmin)
            rlon(j,1)=rlonrd(kmin)
            iconn=iconn+1 
            kconn(iconn)=kmin
            jconn(iconn)=j
            nebconn(iconn)=1
          endif
          if (nec(j).le.1) then
            distmin=180.
            do k=1,krd
              distnew=dist(rlat(j,n1(j)),rlon(j,n1(j)),
     2        rlatrd(k),rlonrd(k))
              if (distnew.lt.distmin) then
                distmin=distnew
                kmin=k
              endif
            enddo
C
C     If the last point is connected to, rather connect to first point, which is identical
C
            if (kmin.eq.krd) kmin=1
            n1(j)=n1(j)+1
            rlat(j,n1(j))=rlatrd(kmin)
            rlon(j,n1(j))=rlonrd(kmin)
            iconn=iconn+1
            kconn(iconn)=kmin
            jconn(iconn)=j
            nebconn(iconn)=2
          endif
        enddo
C
C      Sort points along Pacific-African boundary, which have been connected to by boundaries within Pacific set
C
        nconn=iconn
        iconn2=0
        do k=1,krd
          do iconn=1,nconn
            if (kconn(iconn).eq.k) then
              iconn2=iconn2+1
              kconn2(iconn2)=kconn(iconn)
              jconn2(iconn2)=jconn(iconn)
              nebconn2(iconn2)=nebconn(iconn)
            endif
          enddo
        enddo
        do iconn=1,nconn
          kconn(iconn)=kconn2(iconn)
          jconn(iconn)=jconn2(iconn)
          nebconn(iconn)=nebconn2(iconn)
        enddo
C
C     Step 6: Determine the Pacific set plate on the right-hand side of each segment along the Pacific-African boundary.
C
C     Up to the first point along the Pacific-African boundary that an intra-Pacific plate boundary has been connected to
C     (unless that point is the first point of that boundary):
C     If that point is the end-point of that intra-Pacific boundary, the Pacific set plate for all segments before that point 
C     is the plate on the left-hand of the intra-pacific boundary, 
C     If it is the beginning point, it is on the right hand side. 
C
C     Check consistency, i.e. the “Pacific” plate before each point needs to be the same as “after” the previous point. 
C     The final “Pacific” plate needs to be the same as the initial one, unless the first point of the borderline has 
C     already been connected to.
C
        if (kconn(1).ne.1) then
          do k=2,kconn(1)
            if (nebconn(1).eq.1) n5c(k)=n5(jconn(1))
            if (nebconn(1).eq.2) n5c(k)=n4(jconn(1))
            if (nebconn(1).eq.1) n3c(k)=n3(jconn(1))
            if (nebconn(1).eq.2) n3c(k)=n2(jconn(1))
          enddo
        endif
C
C     After the first point:
C     If that point is the beginning-point of that intra-Pacific boundary, the Pacific set plate for all segments after that point 
C     and before the next one is the plate on the left-hand of the intra-pacific boundary, 
C     If it is the end point, it is on the right hand side. 
C     
        kconn(nconn+1)=krd
        do iconn=1,nconn
          do k=kconn(iconn)+1,kconn(iconn+1)
            if (nebconn(iconn).eq.1) n5c(k)=n4(jconn(iconn))
            if (nebconn(iconn).eq.2) n5c(k)=n5(jconn(iconn))
            if (nebconn(iconn).eq.1) n3c(k)=n2(jconn(iconn))
            if (nebconn(iconn).eq.2) n3c(k)=n3(jconn(iconn))
          enddo
        enddo
        n5c(1)=n5c(2)
        n3c(1)=n3c(2)
C
C     Step 7: Combine consecutive segments of the Pacific-African boundary which agree on plates on both sides.  
C
 499    j=ja+jp+1
        rlat(j,1)=rlatrd(1)
        rlon(j,1)=rlonrd(1)
        n2(j)=n2c(1)
        n3(j)=n3c(1)
        n4(j)=n4c(1)
        n5(j)=n5c(1)
        k2=1
        do k=2,krd
          if ((n2c(k).eq.n2c(k-1)).and.(n3c(k).eq.n3c(k-1))) then
            k2=k2+1
            rlat(j,k2)=rlatrd(k)
            rlon(j,k2)=rlonrd(k)
          else
            n1(j)=k2
            k2=2
            j=j+1
            n2(j)=n2c(k)
            n3(j)=n3c(k)
            n4(j)=n4c(k)
            n5(j)=n5c(k)
            rlat(j,2)=rlatrd(k)
            rlon(j,2)=rlonrd(k)
            rlat(j,1)=rlatrd(k-1)
            rlon(j,1)=rlonrd(k-1)
          endif
        enddo
        n1(j)=k2
        j0=j
C
C     Case that first and last part of Pacific-African boundary have identical plates on both sides
C     Then they are combined to one part
C
        if ((n2c(1).eq.n2c(krd)).and.(n3c(1).eq.n3c(krd))) then
          do k=n1(ja+jp+1),1,-1
            rlat(ja+jp+1,k+n1(j0))=rlat(ja+jp+1,k)
            rlon(ja+jp+1,k+n1(j0))=rlon(ja+jp+1,k)
          enddo
          do k=1,n1(j0)
            rlat(ja+jp+1,k)=rlat(j0,k)
            rlon(ja+jp+1,k)=rlon(j0,k)
          enddo
          n1(ja+jp+1)=n1(ja+jp+1)+n1(j0)
          j0=j0-1
          print *,'first/last part of circum-pacific boundary combined'
        endif

        do j=1,ja
          write (7,11) n1(j),n2(j),n3(j),n4(j),n5(j)
   11     format ('>',5i4)
          write (8,11) n1(j),n2(j),n3(j),n4(j),n5(j)
          do k=1,n1(j)
            write (7,12) rlat(j,k),rlon(j,k)
   12       format (f9.4,1x,f9.4)
            write (8,12) rlat(j,k),rlon(j,k)
          enddo
        enddo
        do j=ja+1,ja+jp
          write (7,11) n1(j),n2(j),n3(j),n4(j),n5(j)
          write (9,11) n1(j),n2(j),n3(j),n4(j),n5(j)
          do k=1,n1(j)
            write (7,12) rlat(j,k),rlon(j,k)
            write (9,12) rlat(j,k),rlon(j,k)
          enddo
        enddo
        do j=ja+jp+1,j0
          write (7,11) n1(j),n2(j),n3(j),n4(j),n5(j)
          write (10,11) n1(j),n2(j),n3(j),n4(j),n5(j)
          do k=1,n1(j)
            write (7,12) rlat(j,k),rlon(j,k)
            write (10,12) rlat(j,k),rlon(j,k)
          enddo
        enddo
        close (7)
        close (8)
        close (9)
        close (10)
C
C     Post-processing: re-construct boundaries around each plate
C     from individual plate boundaries
C
C     Assign boundaries to their respective plates, with the plate always
C     on the right side
C
        do k=1,npl
          ipl=0
          npt3=0
          do j=1,j0
            if (k.eq.n3(j)) then
              ipl=ipl+1
              nptb(ipl)=n1(j)
              npt3=npt3+n1(j)
              do jpt=1,n1(j)
                rdlat(ipl,jpt)=rlat(j,jpt)
                rdlon(ipl,jpt)=rlon(j,jpt)
              enddo
            else if (k.eq.n2(j)) then
              ipl=ipl+1
              nptb(ipl)=n1(j)
              npt3=npt3+n1(j)
              do jpt=1,n1(j)
                rdlat(ipl,jpt)=rlat(j,n1(j)+1-jpt)
                rdlon(ipl,jpt)=rlon(j,n1(j)+1-jpt)
              enddo
            endif
          enddo
          npl2=ipl
C
C     Order plate boundary segments to a closed loop
C
          jpt=0
          do j=1,nptb(1)
            jpt=jpt+1
            rlat1in(jpt)=rdlat(1,j)
            rlon1in(jpt)=rdlon(1,j)
         enddo
          rlatf=rdlat(1,nptb(1))
          rlonf=rdlon(1,nptb(1))
          rlatfm1=rdlat(1,nptb(1)-1)
          rlonfm1=rdlon(1,nptb(1)-1)
          do m=2,npl2
            do l=2,npl2
              if ((dist(rdlat(l,2),rdlon(l,2),rlatfm1,rlonfm1)
     2        .lt.0.00005).and.(nptb(l).gt.3)) then
                do j=3,nptb(l)
                  if (j.gt.3) jpt=jpt+1
                  rlat1in(jpt)=rdlat(l,j)
                  rlon1in(jpt)=rdlon(l,j)
                enddo
                rlatf=rdlat(l,nptb(l))
                rlonf=rdlon(l,nptb(l))
                rlatfm1=rdlat(l,nptb(l)-1)
                rlonfm1=rdlon(l,nptb(l)-1)
                npt3=npt3-2
              else if ((dist(rdlat(l,1),rdlon(l,1),
     3              rlatf,rlonf).lt.0.00005)) then
                do j=2,nptb(l)
                  jpt=jpt+1
                  rlat1in(jpt)=rdlat(l,j)
                  rlon1in(jpt)=rdlon(l,j)
                enddo
                rlatf=rdlat(l,nptb(l))
                rlonf=rdlon(l,nptb(l))
                rlatfm1=rdlat(l,nptb(l)-1)
                rlonfm1=rdlon(l,nptb(l)-1)
              endif
            enddo
          enddo
C
C     Output in same format as input
C
          write (12,1414) i9999a(k),i0a(k)
          write (12,211) idpl2(k),time1p,time2p,c1a(k),i0ba(k),
     2     i999a(k),i0ca(k),npt3-npl2+1
          write (12,9495) rlat1in(1),rlon1in(1),nthree
          do ipt=2,npt3-npl2+1
             write (12,9495) rlat1in(ipt),rlon1in(ipt),ntwo
 9495       format (f9.4,1x,f9.4,1x,i1)
          enddo
          if (dist(rlat1in(npt3-npl2+1),rlon1in(npt3-npl2+1),
     2             rlat1in(1),rlon1in(1)).gt.0.00005) then
            print *,i,k,npt3,npl2,rlat1in(npt3-npl2+1),
     2      rlat1in(1),rlon1in(npt3-npl2+1),rlon1in(1)
          endif 
          write (12,9495) rninetynine,rninetynine,nthree
        enddo
        endif
        if (iend.eq.1) then
          close (11)
          close (12)
          stop
        endif
      enddo
      end

      subroutine chang(rlat,rlon,rmag,omm)
C
C     Rotation matrix from rotation vector according to Chang et al.
C
      implicit real*8(a-h,o-z)
      parameter (pi=3.14159265358979324,conv=pi/180.)
      dimension omm(3,3),tmat(3,3),om(3)
      if (rmag.ne.0) then
      om(1)=rmag*conv*cos(rlat*conv)*cos(rlon*conv)
      om(2)=rmag*conv*cos(rlat*conv)*sin(rlon*conv)
      om(3)=rmag*conv*sin(rlat*conv)
      rho=sqrt(om(1)*om(1)+om(2)*om(2)+om(3)*om(3))
      tmat(1,1)=0.
      tmat(1,2)=-om(3)
      tmat(1,3)=om(2)
      tmat(2,1)=om(3)
      tmat(2,2)=0.
      tmat(2,3)=-om(1)
      tmat(3,1)=-om(2)
      tmat(3,2)=om(1)
      tmat(3,3)=0.
      do i2=1,3
        do j2=1,3
          tmatsq=0.
          do k2=1,3
            tmatsq=tmatsq+tmat(i2,k2)*tmat(k2,j2)
          enddo
          if (rho.eq.0) then
            omm(i2,j2)=0.
          else
            omm(i2,j2)=sin(rho)*tmat(i2,j2)/rho+
     2      (1-cos(rho))*tmatsq/(rho*rho)
          endif
          if (i2.eq.j2) omm(i2,j2)=omm(i2,j2)+1.
        enddo
      enddo
      else
      do i2=1,3
        do j2=1,3
          omm(i2,j2)=0.
          if (i2.eq.j2) omm(i2,j2)=1.
        enddo
      enddo
      endif
      end

      subroutine rotate(rlat,rlon,omm1,omm2)
      implicit real*8(a-h,o-z)
C
C     rotate point from "old" to "new" location
C
      parameter (pi=3.14159265358979324,conv=pi/180.)
      dimension omm1(3,3),omm2(3,3),x(3),xpres(3)

      x(1)=cos(rlon*conv)*cos(rlat*conv)
      x(2)=sin(rlon*conv)*cos(rlat*conv)
      x(3)=sin(rlat*conv)
      xpres(1)=omm2(1,1)*x(1)+omm2(1,2)*x(2)+omm2(1,3)*x(3)
      xpres(2)=omm2(2,1)*x(1)+omm2(2,2)*x(2)+omm2(2,3)*x(3)
      xpres(3)=omm2(3,1)*x(1)+omm2(3,2)*x(2)+omm2(3,3)*x(3)
      x(1)=omm1(1,1)*xpres(1)+omm1(1,2)*xpres(2)+omm1(1,3)*xpres(3)
      x(2)=omm1(2,1)*xpres(1)+omm1(2,2)*xpres(2)+omm1(2,3)*xpres(3)
      x(3)=omm1(3,1)*xpres(1)+omm1(3,2)*xpres(2)+omm1(3,3)*xpres(3)
      call car2sph(x,rlat,rlon)
      end

      subroutine refine(rlat1,rlon1,rlat2,rlon2,dmax,nout,
     2 rlatout,rlonout)
      implicit real*8(a-h,o-z)
C
C     refine spacing of points along line (rlat1,rlon1)-(rlat2,rlon2) to maximum distance dmax
C
      parameter (pi=3.14159265358979324,conv=pi/180.,nref=60)
      dimension rlatout(nref),rlonout(nref),x(3)
      x1=cos(conv*rlat1)*cos(conv*rlon1)
      y1=cos(conv*rlat1)*sin(conv*rlon1)
      z1=sin(conv*rlat1)
      x2=cos(conv*rlat2)*cos(conv*rlon2)
      y2=cos(conv*rlat2)*sin(conv*rlon2)
      z2=sin(conv*rlat2)
      distsq=(x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1)
      dist=2*asin(sqrt(distsq)/2.)*180./pi
      nout=dist/dmax+1
      do i=1,nout
        x(1)=x1*i/nout+x2*(nout-i)/nout
        x(2)=y1*i/nout+y2*(nout-i)/nout
        x(3)=z1*i/nout+z2*(nout-i)/nout
        call car2sph(x,rlatout(i),rlonout(i))
      enddo
      end

      subroutine car2sph(x,rlat,rlon)
      implicit real*8(a-h,o-z)
C
C     Conversion from cartesian to spherical coordinates
C
      parameter (pi=3.14159265358979324,conv=pi/180.)
      dimension x(3)
      if ((x(2).ne.0).or.(x(1).ne.0)) then
        rlat=atan(x(3)/sqrt(x(1)*x(1)+x(2)*x(2)))/conv
        if (x(1).gt.0) then
          rlon=atan(x(2)/x(1))/conv
        else if ((x(1).lt.0).and.(x(2).ge.0)) then
          rlon=atan(x(2)/x(1))/conv+180.
        else if ((x(1).lt.0).and.(x(2).lt.0)) then
          rlon=atan(x(2)/x(1))/conv-180.
        else if ((x(1).eq.0).and.(x(2).gt.0)) then
          rlon=90.
        else if ((x(1).eq.0).and.(x(2).lt.0)) then
          rlon=-90.
        endif
      else if (x(3).gt.0) then
        rlat=90.
        rlon=0.
      else
        rlat=-90.
        rlon=0.
      endif
      end

      function dist(rlat1,rlon1,rlat2,rlon2)
C
C     Distance in degrees between points (rlat1,rlon1) and (rlat2,rlon2)
C
      implicit real*8(a-h,o-z)
      parameter (pi=3.14159265358979324,conv=pi/180.)
      x1=cos(conv*rlat1)*cos(conv*rlon1)
      y1=cos(conv*rlat1)*sin(conv*rlon1)
      z1=sin(conv*rlat1)
      x2=cos(conv*rlat2)*cos(conv*rlon2)
      y2=cos(conv*rlat2)*sin(conv*rlon2)
      z2=sin(conv*rlat2)
      distsq=(x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1)
      dist=2*asin(sqrt(distsq)/2.)*180./pi
      end

      function cross(rt1,rt2,rb1,rb2)
      implicit real*8(a-h,o-z)
C
C     Determines whether two lines [rt1,rt2] and [rb1,rb2] on the surface
C     of a sphere cross each other. This is the case, if rt1 and rt2 lie
C     on opposite sides of the line [rb1,rb2], as well as rb1 and rb2 lie
C     on opposite sides of the line [rt1,rt2].
C
      dimension rt1(3),rt2(3),rb1(3),rb2(3),cp1(3),cp2(3),cp3(3)

      cross=0.
      call cpr(rb2,rb1,cp2)
      call cpr(rt1,rb1,cp1)
      call cpr(cp1,cp2,cp3)
      sp1=spr(cp3,rb1)
      call cpr(rt2,rb1,cp1)
      call cpr(cp1,cp2,cp3)
      sp2=spr(cp3,rb1)

      if (((sp1.lt.0).and.(sp2.gt.0)).or.((sp1.gt.0).and.(sp2.lt.0))) 
     2  then
        call cpr(rt2,rt1,cp2)
        call cpr(rb1,rt1,cp1)
        call cpr(cp1,cp2,cp3)
        sp3=spr(cp3,rt1)
        call cpr(rb2,rt1,cp1)
        call cpr(cp1,cp2,cp3)
        sp4=spr(cp3,rt1)
        if (((sp3.lt.0).and.(sp4.gt.0)).or.((sp3.gt.0).and.(sp4.lt.0))) 
     2    then
          cross=1.
        endif
      endif
      return
      end

      subroutine cpr(x1,x2,cp)
      implicit real*8(a-h,o-z)
C
C     Cross-product cp of vectors x1 and x2
C
      dimension x1(3),x2(3),cp(3)
      cp(1)=x1(2)*x2(3)-x1(3)*x2(2)
      cp(2)=x1(3)*x2(1)-x1(1)*x2(3)
      cp(3)=x1(1)*x2(2)-x1(2)*x2(1)
      return
      end

      function spr(x1,x2)
      implicit real*8(a-h,o-z)
C
C     Scalar product of vectors x1 and x2
C
      dimension x1(3),x2(3)
      spr=x1(1)*x2(1)+x1(2)*x2(2)+x1(3)*x2(3)
      return
      end

      subroutine assemble_sub(npttot,rlat1in,rlon1in,
     2   rlat2in,rlon2in,ipl1in,ipl2in,ipl3in,ipl4in,
     3 nseg,itotb,ipl1b,ipl2b,ipl3b,ipl4b,rlat1,rlon1)
      implicit real*8(a-h,o-z)
C
C     Pre-processing part 2: assemble individual plate boundaries
C
      dimension rlat1(1000,1000),rlat2(1000,1000),rlat4(1000,1000),
     2 rlon1(1000,1000),rlon2(1000,1000),rlon4(1000,1000),
     3  ipl1(100),ipl2(100),ipt(100),itake(1000),
     4 rlat3(10000),rlon3(10000),ipl3(100),ipl4(100),
     5 ipl1b(1000),ipl2b(1000),ipl3b(1000),ipl4b(1000),itotb(1000),
     6 ieq1(100),ieq2(100),rt1(3),rt2(3),rb1(3),rb2(3),
     7 rlat1in(10000),rlat2in(10000),rlon1in(10000),rlon2in(10000),
     8 ipl1in(10000),ipl2in(10000),ipl3in(10000),ipl4in(10000)
      DATA PI/3.1415926535898/
      conv=pi/180.

      iseg=1
      iseg2=0
      ipt(iseg)=1
      rlat1(1,1)=rlat1in(1)
      rlon1(1,1)=rlon1in(1)
      rlat2(1,1)=rlat2in(1)
      rlon2(1,1)=rlon2in(1)
      ipl1(1)=ipl1in(1)
      ipl2(1)=ipl2in(1)
      ipl3(1)=ipl3in(1)
      ipl4(1)=ipl4in(1)
      do ipttot=2,npttot
        rlat1next=rlat1in(ipttot)
        rlon1next=rlon1in(ipttot)
        rlat2next=rlat2in(ipttot)
        rlon2next=rlon2in(ipttot)
        ipl1next=ipl1in(ipttot)
        ipl2next=ipl2in(ipttot)
        ipl3next=ipl3in(ipttot)
        ipl4next=ipl4in(ipttot)
        do jseg=1,iseg
          if ((ipl1next.eq.ipl1(jseg)).and.
     2        (ipl2next.eq.ipl2(jseg))) then
            ipt(jseg)=ipt(jseg)+1
            rlat1(ipt(jseg),jseg)=rlat1next
            rlon1(ipt(jseg),jseg)=rlon1next
            rlat2(ipt(jseg),jseg)=rlat2next
            rlon2(ipt(jseg),jseg)=rlon2next
            goto 199              
          else if ((ipl1next.eq.ipl2(jseg)).and.
     4        (ipl2next.eq.ipl1(jseg))) then
            ipt(jseg)=ipt(jseg)+1
            rlat1(ipt(jseg),jseg)=rlat2next
            rlon1(ipt(jseg),jseg)=rlon2next
            rlat2(ipt(jseg),jseg)=rlat1next
            rlon2(ipt(jseg),jseg)=rlon1next
            goto 199              
         endif
        enddo
        iseg=iseg+1
        ipl1(iseg)=ipl1next
        ipl2(iseg)=ipl2next  
        ipl3(iseg)=ipl3next
        ipl4(iseg)=ipl4next
        rlat1(1,iseg)=rlat1next
        rlon1(1,iseg)=rlon1next
        rlat2(1,iseg)=rlat2next
        rlon2(1,iseg)=rlon2next
        ipt(iseg)=1
 199    continue
      enddo
  99  continue
      do jseg=1,iseg
        do jpt=1,ipt(jseg)
          itake(jpt)=0
        enddo
        rlat3(1)=rlat1(1,jseg)
        rlon3(1)=rlon1(1,jseg)
        rlat3(2)=rlat2(1,jseg)
        rlon3(2)=rlon2(1,jseg)
        x1=cos(rlat3(1)*conv)*cos(rlon3(1)*conv)
        y1=cos(rlat3(1)*conv)*sin(rlon3(1)*conv)
        z1=sin(rlat3(1)*conv)
        x2=cos(rlat3(2)*conv)*cos(rlon3(2)*conv)
        y2=cos(rlat3(2)*conv)*sin(rlon3(2)*conv)
        z2=sin(rlat3(2)*conv)
        itot=2
        itake(1)=1
        do jpt=2,ipt(jseg)
          do kpt=2,ipt(jseg)
            x3=cos(rlat1(kpt,jseg)*conv)*cos(rlon1(kpt,jseg)*conv)
            y3=cos(rlat1(kpt,jseg)*conv)*sin(rlon1(kpt,jseg)*conv)
            z3=sin(rlat1(kpt,jseg)*conv)
            x4=cos(rlat2(kpt,jseg)*conv)*cos(rlon2(kpt,jseg)*conv)
            y4=cos(rlat2(kpt,jseg)*conv)*sin(rlon2(kpt,jseg)*conv)
            z4=sin(rlat2(kpt,jseg)*conv)
            distsq=(x2-x3)*(x2-x3)+(y2-y3)*(y2-y3)+(z2-z3)*(z2-z3)
            distsq2=(x1-x4)*(x1-x4)+(y1-y4)*(y1-y4)+(z1-z4)*(z1-z4)
            if ((distsq.lt.3.e-6).and.(itake(kpt).eq.0)) then
              itot=itot+1
              rlat3(itot)=rlat2(kpt,jseg)
              rlon3(itot)=rlon2(kpt,jseg)
              itake(kpt)=1
              x2=x4
              y2=y4
              z2=z4
              goto 399
            else if ((distsq2.lt.3.e-6).and.(itake(kpt).eq.0)) then
              do jtot=1,itot
                rlat3(itot+2-jtot)=rlat3(itot+1-jtot)
                rlon3(itot+2-jtot)=rlon3(itot+1-jtot)
              enddo
              itot=itot+1
              rlat3(1)=rlat1(kpt,jseg)
              rlon3(1)=rlon1(kpt,jseg)
              itake(kpt)=1
              x1=x3
              y1=y3
              z1=z3
              goto 399
            endif
          enddo
  399     continue
        enddo

        iseg2=iseg2+1
        itotb(iseg2)=itot
        ipl1b(iseg2)=ipl1(jseg)
        ipl2b(iseg2)=ipl2(jseg)
        ipl3b(iseg2)=ipl3(jseg)
        ipl4b(iseg2)=ipl4(jseg)
        do i=1,itot
          rlat4(i,iseg2)=rlat3(i)
          rlon4(i,iseg2)=rlon3(i)
        enddo
C
C      Second round?
C
        irestart=0
        do jpt=1,ipt(jseg)
          if (itake(jpt).eq.0) then
             irestart=1             
             jpt0=jpt
             goto 499
          endif
        enddo          
  499   continue

        if (irestart.eq.1) then
C
C     Second round
C
          rlat3(1)=rlat1(jpt0,jseg)
          rlon3(1)=rlon1(jpt0,jseg)
          rlat3(2)=rlat2(jpt0,jseg)
          rlon3(2)=rlon2(jpt0,jseg)
          x1=cos(rlat3(1)*conv)*cos(rlon3(1)*conv)
          y1=cos(rlat3(1)*conv)*sin(rlon3(1)*conv)
          z1=sin(rlat3(1)*conv)
          x2=cos(rlat3(2)*conv)*cos(rlon3(2)*conv)
          y2=cos(rlat3(2)*conv)*sin(rlon3(2)*conv)
          z2=sin(rlat3(2)*conv)
          itot=2
          itake(jpt0)=1
          do jpt=2,ipt(jseg)
            do kpt=2,ipt(jseg)
              x3=cos(rlat1(kpt,jseg)*conv)*cos(rlon1(kpt,jseg)*conv)
              y3=cos(rlat1(kpt,jseg)*conv)*sin(rlon1(kpt,jseg)*conv)
              z3=sin(rlat1(kpt,jseg)*conv)
              x4=cos(rlat2(kpt,jseg)*conv)*cos(rlon2(kpt,jseg)*conv)
              y4=cos(rlat2(kpt,jseg)*conv)*sin(rlon2(kpt,jseg)*conv)
              z4=sin(rlat2(kpt,jseg)*conv)
              distsq=(x2-x3)*(x2-x3)+(y2-y3)*(y2-y3)+(z2-z3)*(z2-z3)
              distsq2=(x1-x4)*(x1-x4)+(y1-y4)*(y1-y4)+(z1-z4)*(z1-z4)
              if ((distsq.lt.3.e-6).and.(itake(kpt).eq.0)) then
                itot=itot+1
                rlat3(itot)=rlat2(kpt,jseg)
                rlon3(itot)=rlon2(kpt,jseg)
                itake(kpt)=1
                x2=x4
                y2=y4
                z2=z4
                goto 599
              else if ((distsq2.lt.3.e-6).and.(itake(kpt).eq.0)) then
                do jtot=1,itot
                  rlat3(itot+2-jtot)=rlat3(itot+1-jtot)
                  rlon3(itot+2-jtot)=rlon3(itot+1-jtot)
                enddo
                itot=itot+1
                rlat3(1)=rlat1(kpt,jseg)
                rlon3(1)=rlon1(kpt,jseg)
                itake(kpt)=1
                x1=x3
                y1=y3
                z1=z3
                goto 599
              endif
            enddo
  599       continue
          enddo

          iseg2=iseg2+1
          itotb(iseg2)=itot
          ipl1b(iseg2)=ipl1(jseg)
          ipl2b(iseg2)=ipl2(jseg)
          ipl3b(iseg2)=ipl3(jseg)
          ipl4b(iseg2)=ipl4(jseg)
          do i=1,itot
            rlat4(i,iseg2)=rlat3(i)
            rlon4(i,iseg2)=rlon3(i)
          enddo

        endif
C
C     Third round
C
        irestart=0
        do jpt=1,ipt(jseg)
          if (itake(jpt).eq.0) then
             irestart=1             
             jpt0=jpt
          endif
        enddo
          
  699   continue

      enddo

      nseg=iseg2
C
C     Connect triple junctions
C
      itot=0
      do iseg=1,nseg
        ieq1(iseg)=0
        ieq2(iseg)=0
        do jseg=1,nseg
          x1=cos(rlat4(1,jseg)*conv)*cos(rlon4(1,jseg)*conv)
          y1=cos(rlat4(1,jseg)*conv)*sin(rlon4(1,jseg)*conv)
          z1=sin(rlat4(1,jseg)*conv)
          x2=cos(rlat4(itotb(jseg),jseg)*conv)
     2      *cos(rlon4(itotb(jseg),jseg)*conv)
          y2=cos(rlat4(itotb(jseg),jseg)*conv)
     2      *sin(rlon4(itotb(jseg),jseg)*conv)
          z2=sin(rlat4(itotb(jseg),jseg)*conv)
          x3=cos(rlat4(1,iseg)*conv)*cos(rlon4(1,iseg)*conv)
          y3=cos(rlat4(1,iseg)*conv)*sin(rlon4(1,iseg)*conv)
          z3=sin(rlat4(1,iseg)*conv)
          x4=cos(rlat4(itotb(iseg),iseg)*conv)
     2      *cos(rlon4(itotb(iseg),iseg)*conv)
          y4=cos(rlat4(itotb(iseg),iseg)*conv)
     2      *sin(rlon4(itotb(iseg),iseg)*conv)
          z4=sin(rlat4(itotb(iseg),iseg)*conv)
          distsq1=(x1-x3)*(x1-x3)+(y1-y3)*(y1-y3)+(z1-z3)*(z1-z3)
          distsq2=(x1-x4)*(x1-x4)+(y1-y4)*(y1-y4)+(z1-z4)*(z1-z4)
          distsq3=(x2-x3)*(x2-x3)+(y2-y3)*(y2-y3)+(z2-z3)*(z2-z3)
          distsq4=(x2-x4)*(x2-x4)+(y2-y4)*(y2-y4)+(z2-z4)*(z2-z4)
          if (distsq1.lt.3.e-6) then
            ieq1(iseg)=ieq1(iseg)+1
            rlat4(1,jseg)=rlat4(1,iseg)
            rlon4(1,jseg)=rlon4(1,iseg)
          endif
          if (distsq3.lt.3.e-6) then
            ieq1(iseg)=ieq1(iseg)+1
            rlat4(itotb(jseg),jseg)=rlat4(1,iseg)
            rlon4(itotb(jseg),jseg)=rlon4(1,iseg)
          endif
          if (distsq2.lt.3.e-6) then
            ieq2(iseg)=ieq2(iseg)+1
            rlat4(1,jseg)=rlat4(itotb(iseg),iseg)
            rlon4(1,jseg)=rlon4(itotb(iseg),iseg)
          endif
          if (distsq4.lt.3.e-6) then
            ieq2(iseg)=ieq2(iseg)+1
            rlat4(itotb(jseg),jseg)=rlat4(itotb(iseg),iseg)
            rlon4(itotb(jseg),jseg)=rlon4(itotb(iseg),iseg)
          endif
        enddo
      enddo
      ntot=itot
C
C     Check for lines crossing
C
      do iseg=1,nseg
        do i=1,itotb(iseg)-1
          rt1(1)=cos(rlat4(i,iseg)*conv)*cos(rlon4(i,iseg)*conv)
          rt1(2)=cos(rlat4(i,iseg)*conv)*sin(rlon4(i,iseg)*conv)
          rt1(3)=sin(rlat4(i,iseg)*conv)
          rt2(1)=cos(rlat4(i+1,iseg)*conv)*cos(rlon4(i+1,iseg)*conv)
          rt2(2)=cos(rlat4(i+1,iseg)*conv)*sin(rlon4(i+1,iseg)*conv)
          rt2(3)=sin(rlat4(i+1,iseg)*conv)
          do jseg=1,nseg
            do j=1,itotb(jseg)-1
              rb1(1)=cos(rlat4(j,jseg)*conv)*cos(rlon4(j,jseg)*conv)
              rb1(2)=cos(rlat4(j,jseg)*conv)*sin(rlon4(j,jseg)*conv)
              rb1(3)=sin(rlat4(j,jseg)*conv)
             rb2(1)=cos(rlat4(j+1,jseg)*conv)*cos(rlon4(j+1,jseg)*conv)
             rb2(2)=cos(rlat4(j+1,jseg)*conv)*sin(rlon4(j+1,jseg)*conv)
             rb2(3)=sin(rlat4(j+1,jseg)*conv)
              distsq=(rt1(1)+rt2(1)-rb1(1)-rb2(1))*
     2               (rt1(1)+rt2(1)-rb1(1)-rb2(1))+
     3               (rt1(2)+rt2(2)-rb1(2)-rb2(2))*
     4               (rt1(2)+rt2(2)-rb1(2)-rb2(2))+
     5               (rt1(3)+rt2(3)-rb1(3)-rb2(3))*
     6               (rt1(3)+rt2(3)-rb1(3)-rb2(3))

              if ((cross(rt1,rt2,rb1,rb2).gt.0).and.(distsq.lt.4)) 
     2        print *,'crossing (',
     3        rlat4(i,iseg),',',rlon4(i,iseg),') --> (',
     4        rlat4(i+1,iseg),',',rlon4(i+1,iseg),') with (',
     5        rlat4(j,jseg),',',rlon4(j,jseg),') --> (',
     6        rlat4(j+1,jseg),',',rlon4(j+1,jseg)
            enddo
          enddo
        enddo
      enddo

      do iseg=1,nseg
        do i=1,itotb(iseg)
          rlat1(iseg,i)=rlat4(i,iseg)
          rlon1(iseg,i)=rlon4(i,iseg)
        enddo
      enddo
C      stop
      end

      subroutine disassemble(npl,idpl,idpl2,n0,rlat,rlon,
     2     npttot,rlat1,rlon1,rlat2,rlon2,ipl1,ipl2,ipl3,ipl4)
      implicit real*8(a-h,o-z)
C
C     Pre-processing part 1: disassemble boundaries around each plate into individual segments
C
      dimension rlat(100,2000),rlon(100,2000),rpt(4,3),rseg(3),
     2 n0(100),idpl(100),ipair(100,2000),
     3 idpl2(100),ipl1(10000),ipl2(10000),ipl3(10000),ipl4(10000),
     4 rlat1(10000),rlat2(10000),rlon1(10000),rlon2(10000)
      DATA PI/3.1415926535898/
      conv=pi/180.

      npttot=0
      do ipl=1,npl
	do ipt=1,n0(ipl)-1
	  ipair(ipl,ipt)=0
	enddo
      enddo

      do ipl=1,npl-1
	do ipt=1,n0(ipl)-1
          rpt(1,1)=cos(rlat(ipl,ipt)*conv)*cos(rlon(ipl,ipt)*conv)
          rpt(1,2)=cos(rlat(ipl,ipt)*conv)*sin(rlon(ipl,ipt)*conv)
          rpt(1,3)=sin(rlat(ipl,ipt)*conv)
          rpt(2,1)=cos(rlat(ipl,ipt+1)*conv)*cos(rlon(ipl,ipt+1)*conv)
          rpt(2,2)=cos(rlat(ipl,ipt+1)*conv)*sin(rlon(ipl,ipt+1)*conv)
          rpt(2,3)=sin(rlat(ipl,ipt+1)*conv)
          if ((rpt(1,1)-rpt(2,1))*(rpt(1,1)-rpt(2,1))+
     2       (rpt(1,2)-rpt(2,2))*(rpt(1,2)-rpt(2,2))+
     3       (rpt(1,3)-rpt(2,3))*(rpt(1,3)-rpt(2,3)).lt.1.e-10)
     4       write (6,15) ,rlat(ipl,ipt),rlon(ipl,ipt),
     5        rlat(ipl,ipt+1),rlon(ipl,ipt+1)
  15        format (f9.4,1x,f9.4,1x,f9.4,1x,f9.4,
     2        'zero distance')
          if (ipair(ipl,ipt).eq.0) then
	    do jpl=ipl+1,npl
	      do jpt=1,n0(jpl)-1
               rpt(3,1)=cos(rlat(jpl,jpt)*conv)*cos(rlon(jpl,jpt)*conv)
               rpt(3,2)=cos(rlat(jpl,jpt)*conv)*sin(rlon(jpl,jpt)*conv)
               rpt(3,3)=sin(rlat(jpl,jpt)*conv)
           rpt(4,1)=cos(rlat(jpl,jpt+1)*conv)*cos(rlon(jpl,jpt+1)*conv)
           rpt(4,2)=cos(rlat(jpl,jpt+1)*conv)*sin(rlon(jpl,jpt+1)*conv)
                rpt(4,3)=sin(rlat(jpl,jpt+1)*conv)
                if (((rpt(1,1)-rpt(4,1))*(rpt(1,1)-rpt(4,1))+
     2          (rpt(1,2)-rpt(4,2))*(rpt(1,2)-rpt(4,2))+
     3          (rpt(1,3)-rpt(4,3))*(rpt(1,3)-rpt(4,3)).lt.3.e-6).and.
     5          ((rpt(2,1)-rpt(3,1))*(rpt(2,1)-rpt(3,1))+
     2          (rpt(2,2)-rpt(3,2))*(rpt(2,2)-rpt(3,2))+
     3          (rpt(2,3)-rpt(3,3))*(rpt(2,3)-rpt(3,3)).lt.3.e-6)) then
                  ipair(jpl,jpt)=1
                  do idir=1,3
                    rseg(idir)=(rpt(1,idir)+rpt(2,idir))/2.
                  enddo
                  rsegabs=sqrt(rseg(1)**2+rseg(2)**2+rseg(3)**2)
                  do idir=1,3
                    rseg(idir)=rseg(idir)/rsegabs
                  enddo
                  distsq=(rpt(1,1)-rpt(2,1))*(rpt(1,1)-rpt(2,1))+
     2             (rpt(1,2)-rpt(2,2))*(rpt(1,2)-rpt(2,2))+
     3             (rpt(1,3)-rpt(2,3))*(rpt(1,3)-rpt(2,3))
                  dist=sqrt(distsq)
	          ndist=int(dist/conv)+1
                  npttot=npttot+1
                  rlat1(npttot)=rlat(ipl,ipt)
                  rlon1(npttot)=rlon(ipl,ipt)
                  rlat2(npttot)=rlat(ipl,ipt+1)
                  rlon2(npttot)=rlon(ipl,ipt+1)
                  ipl1(npttot)=idpl(jpl)
                  ipl2(npttot)=idpl(ipl)
                  ipl3(npttot)=idpl2(jpl)
                  ipl4(npttot)=idpl2(ipl)
                  goto 199
	        endif
	      enddo
	    enddo
            write (6,14) ,rlat(ipl,ipt),rlon(ipl,ipt),
     2      rlat(ipl,ipt+1),rlon(ipl,ipt+1)
  14        format (f9.4,1x,f9.4,1x,f9.4,1x,f9.4,
     2      'no matching pair found')
 199        continue
          endif
        enddo
      enddo
  299 end
